﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Bezier1
{
 public partial class Page : UserControl
 {
  Rectangle[] tabMarques;
  Point PosPrec;
  int nMarqueEnDéplacement = -1;  // indique quelle marque est en cours de déplacement
  public Page()
  {
   InitializeComponent();
  }

  private void LayoutRoot_Loaded(object sender, RoutedEventArgs e)
  {
   tabMarques = new Rectangle[3];
   tabMarques[0] = M0; tabMarques[1] = M1; tabMarques[2] = M2;
   for (int i = 0; i < tabMarques.Length; i++)
   {
    tabMarques[i].MouseLeftButtonDown+=new MouseButtonEventHandler(Marque_MouseLeftButtonDown);   
    tabMarques[i].MouseMove += new MouseEventHandler(Marque_MouseMove);
    tabMarques[i].MouseLeftButtonUp+=new MouseButtonEventHandler(Marque_MouseLeftButtonUp);  
   }
   DisplayParameters();
  }
  void Marque_MouseLeftButtonDown(object sender, MouseEventArgs e)
  {
   Rectangle r = sender as Rectangle;
   if (r != null)
   {
    Point p = e.GetPosition(this);
    string s = r.Name.Substring(1);
    int nMarque = Int32.Parse(s);
    nMarqueEnDéplacement = nMarque;
    PosPrec = p;
    tabMarques[nMarque].CaptureMouse();
   }
  }
  void Marque_MouseMove(object sender, MouseEventArgs e)
  {
   Rectangle r = sender as Rectangle;
   if (r != null)
   {
    // une de nos trois marques. Laquelle ?
    string s = r.Name.Substring(1);
    int nMarque = Int32.Parse(s);
    if (nMarqueEnDéplacement == nMarque)
    {
     double deltaX, deltaY;
     Point p = e.GetPosition(this);
     deltaX = p.X - PosPrec.X;
     deltaY = p.Y - PosPrec.Y;
     double X = (double)tabMarques[nMarque].GetValue(Canvas.LeftProperty);
     double Y = (double)tabMarques[nMarque].GetValue(Canvas.TopProperty);
     tabMarques[nMarque].SetValue(Canvas.LeftProperty, X + deltaX);
     tabMarques[nMarque].SetValue(Canvas.TopProperty, Y + deltaY);
     PosPrec = p;
     // créer la courbe de Bézier modifiée
     Figs.Segments.Clear();
     QuadraticBezierSegment qbs = new QuadraticBezierSegment();
     Point[] tP = new Point[3];
     for (int i = 0; i < tP.Length; i++)
     {
      tP[i].X = (double)tabMarques[i].GetValue(Canvas.LeftProperty) + 5;
      tP[i].Y = (double)tabMarques[i].GetValue(Canvas.TopProperty) + 5;
     }
     qbs.Point1 = tP[1];
     qbs.Point2 = tP[2];
     Figs.StartPoint = tP[0];
     Figs.Segments.Add(qbs);
     DisplayParameters();
    }
   }
  }

  void Marque_MouseLeftButtonUp(object sender, MouseEventArgs e)
  {
   Rectangle r = sender as Rectangle;
   if (r != null)
   {
    // de quelle marque s'agit-il ? 
    string s = r.Name.Substring(1);
    int nMark = Int32.Parse(s);
    nMarqueEnDéplacement = -1;
    tabMarques[nMark].ReleaseMouseCapture();
   }
  }

  void DisplayParameters()
  {
   Point[] tP = new Point[3];
   for (int i = 0; i < 3; i++)
   {
    tP[i].X = (double)tabMarques[i].GetValue(Canvas.LeftProperty) + 5;
    tP[i].Y = (double)tabMarques[i].GetValue(Canvas.TopProperty) + 5;
   }
   tbStPt.Text = tP[0].X + " - " + tP[0].Y;
   tbEndPt.Text = tP[2].X + " - " + tP[2].Y;
   tbCtrlPt.Text = tP[1].X + " - " + tP[1].Y;
  }
 }
}
